=== debian/changelog ===
u-boot (2013.10-3) unstable; urgency=low

  * Move build of dbau1100 from mipsel to mips, which fixes FTBFS on mipsel,
    due to dbau1100 being big-endian.
  * Disable mipsel builds of u-boot, as it no longer has any targets.
  * Add patch to specify default mmc partition to use when loading uEnv.txt
    on BeagleBone Black.
  * Add patch to support raw initrds on BeagleBone Black.
  * Mark u-boot-tools as Multi-Arch: foreign.
  * Mark u-boot as Multi-Arch: same.
  * Update lintian overrides with list of current platforms.

 -- Vagrant Cascadian <vagrant@debian.org>  Sun, 17 Nov 2013 00:09:32 -0800

u-boot (2013.10-2) unstable; urgency=low

  * debian/rules:
    - Switch back to explicitly building the specified target.
    - Allow building multiple targets per platform.
  * debian/targets:
    - Build the spl/u-boot-spl.bin target on several armhf platforms, which 
      generates the MLO file.

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 21 Oct 2013 11:33:01 -0700

u-boot (2013.10-1) unstable; urgency=low

  * New upstream version (Closes: #667680, #726699).
    - Update mipsel-native-endianness.diff
  * debian/rules:
    - Remove various tools/* files on clean target.
    - Build each platform target and install MLO file if present.
      (Closes: #687562).
    - Support parallel builds using DEB_BUILD_OPTIONS=parallel=N.
  * Enable BeagleBone Black and Wandboard platforms.
  * Add patch to support uEnv.txt and directly loading zimage for Wandboard.
  * Include env configs u-boot-tools examples (Closes: #631659, #636214).
  * Only build u-boot on architectures which generate images (Closes: #635050).
  * Drop i386 builds of u-boot, as the only target (eNET) was removed upstream.
  * debian/control: Add myself to uploaders.

 -- Vagrant Cascadian <vagrant@debian.org>  Sun, 20 Oct 2013 10:23:55 -0700
