=== debian/control ===
Source: u-boot
Section: admin
Priority: optional
Maintainer: Clint Adams <clint@debian.org>
Uploaders: Loïc Minier <lool@debian.org>, Micah Anderson <micah@debian.org>, Vagrant Cascadian <vagrant@debian.org>
Standards-Version: 3.9.4
Homepage: http://www.denx.de/wiki/U-Boot/
Vcs-Git: git://git.debian.org/collab-maint/u-boot.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/u-boot.git;a=summary

Package: u-boot
Architecture: armel armhf avr32 mips powerpc sh4
Multi-Arch: same
Description: A boot loader for embedded systems
 Das U-Boot is a cross-platform bootloader for embedded systems,
 used as the default boot loader by several board vendors.  It is
 intended to be easy to port and to debug, and runs on many
 supported architectures, including PPC, ARM, MIPS, x86, m68k,
 NIOS, and Microblaze.

Package: u-boot-tools
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}
Breaks: uboot-envtools (<< 20081215-3~),
        uboot-mkimage (<= 0.4build1),
        u-boot (<< 2010.12-2)
Replaces: uboot-envtools (<< 20081215-3~),
          uboot-mkimage (<= 0.4build1),
          u-boot (<< 2010.12-2)
Description: companion tools for Das U-Boot bootloader
 This package includes the mkimage program, which allows generation of U-Boot
 images in various formats, and the fw_printenv and fw_setenv programs to read
 and modify U-Boot's environment.
